// $Id: ColorScheme.h 96 2007-03-21 13:42:51Z olau $

#ifndef __COLORSCHEME_H_
#define __COLORSCHEME_H_
#include <sys/stat.h>
#include <math.h>

typedef unsigned int QRgb; 
static const int maxColors = 16*1024*1024;
QRgb qRgb(int r,int b,int g); 

void SetColorScheme(QRgb* Table,int off, int size);

//double pow(double base, double ex)
//{return  exp (ex*log (base)); }
 
QRgb qRgb(int r,int b,int g) 
{
	return ((r & 0xff) << 16) + ((b & 0xff) << 8) + (g & 0xff);   
}

QRgb rgbFromWaveLength(double wave)
{
    double r = 0.0;
    double g = 0.0;
    double b = 0.0;
	double s;

    if (wave >= 380.0 && wave <= 440.0) {
        r = -1.0 * (wave - 440.0) / (440.0 - 380.0);
        b = 1.0;
    }
    else if (wave >= 440.0 && wave <= 490.0) {
        g = (wave - 440.0) / (490.0 - 440.0);
        b = 1.0;
    }
    else if (wave >= 490.0 && wave <= 510.0) {
        g = 1.0;
        b = -1.0 * (wave - 510.0) / (510.0 - 490.0);
    }
    else if (wave >= 510.0 && wave <= 580.0) {
        r = (wave - 510.0) / (580.0 - 510.0);
        g = 1.0;
    }
    else if (wave >= 580.0 && wave <= 645.0) {
        r = 1.0;
        g = -1.0 * (wave - 645.0) / (645.0 - 580.0);
    }
    else if (wave >= 645.0 && wave <= 780.0) {
        r = 1.0;
    }

    s = 1.0;
    if (wave > 700.0)
        s = 0.3 + 0.7 * (780.0 - wave) / (780.0 - 700.0);
    else if (wave <  420.0)
        s = 0.3 + 0.7 * (wave - 380.0) / (420.0 - 380.0);

    r = pow(r * s, 0.8);
    g = pow(g * s, 0.8);
    b = pow(b * s, 0.8);
/*
    r =r*s;
    g =g*s;
    b =b*s;
*/
    return qRgb((int)(r * 255), (int)(g * 255), (int)(b * 255));
}


void SetColorScheme(QRgb* Table,int off,int size)
{
	int i; 
    for (i = 0; i < size; ++i)
        Table[(i+off) % size] = rgbFromWaveLength(380.0 + (i * 400.0 / size));
}



#endif // __COLORSCHEME_H_
