/* --------------------------------------------------------------  */
/* (C)Copyright  2007,                                             */
/* Andreas Stiller                                                 */
/* Redaktion c't                                                   */
/* Heise Zeitschrifen Verlag GmbH & Co Kg                          */
/*                                                                 */
/* All Rights Reserved.                                            */
/* --------------------------------------------------------------  */

#include <stdio.h>
#include <spu_mfcio.h>
#include <profile.h>
#include "spe.h"

typedef vec_uint4 btype;

vec_float4 fNull={0,0,0,0}; 
vec_uint4  iNull={0,0,0,0}; 
vec_uint4  iEins={1,1,1,1};
vec_float4 fZwei={2,2,2,2};
int xmax,maxiter;

// unrool-Faktor 1 bis 5 hier eingeben
#define loop 5

vec_float4 DR,G2,DR2;
vec_float4 vR0;
vec_float4 vA,vB,vA2,vB2,vAB,vA2B2,DR4;
vec_uint4  vINC,vC,vCOUNT;
 
 
#if loop >1
 	vec_float4 wA,wB,wA2,wB2,wAB,wA2B2,DR8;
	vec_uint4  wINC,wC,wCOUNT;
#endif  

#if loop >2
	vec_float4 xA,xB,xA2,xB2,xAB,xA2B2,DR12;
	vec_uint4  xINC,xC,xCOUNT;
#endif

#if loop >3   	
	vec_float4 yA,yB,yA2,yB2,yAB,yA2B2,DR16;
	vec_uint4  yINC,yC,yCOUNT;  
#endif    

#if loop >4   	
	vec_float4 zA,zB,zA2,zB2,zAB,zA2B2,DR20;
	vec_uint4  zINC,zC,zCOUNT;  
#endif 


// Hier die generische Apfelmännchenroutine 
void Line_Gen_D_C (const float r0, const float i0, const float dr, const float g, int xmax, int maxiter, u32 *pCount) 
{

	float r=r0; 
	float G2=g*g;
	int j,c;
	for (j=0;j<xmax;++j) { 
		float a=0.0,b=0.0,a2=0.0,b2=0.0;
		float ab,a2b2; 
		u32 count=0;  
		int icount = 0;
   
		do{
		   ab=a*b;
	           b=ab+ab+i0;
		   a=a2-b2+r;
      	           a2=a*a;
	 	   b2=b*b; 
                   a2b2=a2+b2; 
		   c= (G2>=a2+b2);
		   if (c) count++;
		 }
		while (++icount <maxiter && c);
		*pCount++ = count;

		r +=dr;
	}
	return; 
}
 
void setconst (const float r0,const float dr, const float g, const int axmax, const int amaxiter) {
	 
 DR=(vec_float4){dr,dr,dr,dr};
 G2=(vec_float4){g*g,g*g,g*g,g*g};
 DR2=DR+DR;
 vR0=(vec_float4){r0,r0+dr,r0+2*dr,r0+3*dr};
 DR4=DR2+DR2;
 maxiter=amaxiter;
#if   loop ==1
        xmax= (axmax+3) >>2; //4 Punkte  
#elif loop ==2 
        xmax= (axmax+7) >>3; //8 Punkte 
#elif loop ==3 
        xmax=(axmax+11)/12; // 12 Punkte 
#elif loop ==4
        xmax= (axmax +15) >>4;  // 16 Punkte
#elif loop ==5 
        xmax=(axmax+19) /20;   // 20 Punkte   
#endif     
  
  
#if loop >1  
	DR8=DR4+DR4;	
#endif  
#if loop >2
        DR12=DR8+DR4;
#endif
#if loop >3   	
    	DR16=DR12+DR4;  
#endif    
#if loop >4   	
    	DR20=DR16+DR4;   
#endif 
} 
 

void Line_Gen (const float i0,btype *pCount) {
 	int j,icount;
	vec_uint4  Gx; 
 	vec_float4 I0={i0,i0,i0,i0}; 
#if loop > 0
        vec_float4 vR=vR0;
#endif
#if loop >1  
	vec_float4 wR=vR+DR4;	
#endif  
#if loop >2
        vec_float4 xR=wR+DR4;
#endif
#if loop >3   	
    	 vec_float4 yR=xR+DR4;
#endif    
#if loop >4   	
    	vec_float4 zR=yR+DR4;
#endif 
 

	for (j=0;j<xmax;j++) { 
#if loop >0 
	vA=fNull;vB=fNull,vA2=fNull,vB2=fNull; 
	vINC=iEins; vCOUNT = iNull;
#endif
#if loop >1
	wA=fNull;wB=fNull,wA2=fNull,wB2=fNull; 
	wINC=iEins; wCOUNT = iNull;
#endif
#if loop >2
	xA=fNull;xB=fNull,xA2=fNull,xB2=fNull;
	xINC=iEins; xCOUNT = iNull; 
#endif
#if loop >3
	yA=fNull;yB=fNull,yA2=fNull,yB2=fNull; 
	yINC=iEins; yCOUNT = iNull;
#endif
#if loop >4
	zA=fNull;zB=fNull,zA2=fNull,zB2=fNull; 
	zINC=iEins; zCOUNT = iNull;
#endif
	icount=0; 
   do{     
#if loop >0            
	vAB=vA*vB;
#endif
#if loop >1            
	wAB=wA*wB;
#endif
#if loop >2 		
	xAB=xA*xB;
#endif
#if loop >3            
	yAB=yA*yB;
#endif
#if loop >4            
	zAB=zA*zB;
#endif
             
#if loop >0 		
	vB=fZwei*vAB+I0;
#endif
#if loop >1            
	wB=fZwei*wAB+I0;
#endif
#if loop >2 		
	xB=fZwei*xAB+I0;
#endif
#if loop >3            
	yB=fZwei*yAB+I0;
#endif
#if loop >4           
	zB=fZwei*zAB+I0;
#endif
 
#if loop >0            
	vA=vA2-vB2+vR;
#endif
#if loop >1            
	wA=wA2-wB2+wR;
#endif 
#if loop >2 	 	
	xA=xA2-xB2+xR;
#endif
#if loop >3            
	yA=yA2-yB2+yR;
#endif
#if loop >4            
	zA=zA2-zB2+zR;
#endif
#if loop >0            
	vA2=vA*vA;
#endif
#if loop >1 		
	wA2=wA*wA;
#endif
#if loop >2	       	
	xA2=xA*xA;
#endif
#if loop >3		
	yA2=yA*yA;
#endif

#if loop >4		
	zA2=zA*zA;
#endif

#if loop >0           	
	vB2=vB*vB;
#endif

#if loop >1 		
	wB2=wB*wB;
#endif
#if loop >2	        
	xB2=xB*xB;
#endif
#if loop >3		
	yB2=yB*yB;
#endif
#if loop >4		
	zB2=zB*zB;
#endif

#if loop >0		
	vA2B2=vA2+vB2;
#endif
#if loop >1            
	wA2B2=wA2+wB2;
#endif
#if loop >2            
	xA2B2=xA2+xB2;
#endif
#if loop >3           	
	yA2B2=yA2+yB2;
#endif

#if loop >4           	
	zA2B2=zA2+zB2;
#endif
			
#if loop >0		
	vC=spu_cmpgt (G2,vA2B2); //G2>vA2B2 =-1, G2 <=vA2B2 => 0
#endif 
#if loop >1		
	wC=spu_cmpgt (G2,wA2B2);
#endif 
#if loop >2          	
	xC=spu_cmpgt (G2,xA2B2);
#endif
#if loop >3            
	yC=spu_cmpgt (G2,yA2B2);
#endif 

#if loop >4            
	zC=spu_cmpgt (G2,zA2B2);
#endif 
/*  
für Grenzen >= 2 kann direkt das Vergleichsergebnis  VC, WC ... als Maske verwendet werden
#if loop >0			
	vINC = vINC & vC;
#endif
#if loop >1 			
	wINC = wINC & wC;
#endif
#if loop >2			
	xINC = xINC & xC;
#endif
#if loop >3 			
	yINC = yINC & yC;
#endif
         
#if loop >4			
	zINC = zINC & zC;
#endif
*/ 
   
#if loop >0			
	vCOUNT -= vC;
        Gx = spu_gather (vC);
#endif
#if loop >1 			
	wCOUNT -= wC;
        Gx |= spu_gather (wC);
#endif
#if loop >2			
	xCOUNT -= xC;
        Gx |= spu_gather (xC);
#endif
#if loop >3 			
	yCOUNT -= yC;

        Gx |= spu_gather (yC);
#endif

#if loop >4 			
	zCOUNT -= zC;
        Gx |= spu_gather (zC);
#endif
      
       
	}
	while ((++icount <maxiter) && spu_extract (Gx,0));
#if loop >0                
	*pCount++ = vCOUNT;
#endif 
#if loop >1                
	*pCount++ = wCOUNT;
#endif   
#if loop >2		    
	*pCount++ = xCOUNT;
#endif
#if loop >3		    
	*pCount++ = yCOUNT;
#endif
#if loop >4		    
	*pCount++ = zCOUNT;
#endif

      
#if   (loop==1)               
	vR +=DR4;
#elif (loop == 2)
        vR +=DR8; 		   
	wR +=DR8;
#elif (loop == 3)
        vR +=DR12;               
	wR +=DR12;
	xR +=DR12;
#elif (loop == 4)
        vR +=DR16;               
	wR +=DR16;
	xR +=DR16;
        yR +=DR16;
#elif (loop == 5)
        vR +=DR20;               
	wR +=DR20;
	xR +=DR20;
        yR +=DR20;
        zR +=DR20;
#endif
     }
return;
}

#define maxlen 2048
unsigned int line1[maxlen] __attribute__ ((aligned (128)));
unsigned int line2[maxlen] __attribute__ ((aligned (128)));

int main(u64 id, addr64 argp) {
        addr64 target;
        float i;
        int l; 
        struct dma_packet cb;
	enum {tag1 = 1, tag2=2};
 	mfc_get(&cb, argp.ull, sizeof(struct dma_packet), tag1, 0 ,0);
	mfc_write_tag_mask(1 << tag1);
	mfc_read_tag_status_all();
        target=cb.targetaddr;
        i= (float) cb.i; 
       if (cb.verbose) printf ("id:0x%llx r=%f i=%f dr=%f g=%f w=%d, lines=%d  adr=%llx \n",id,cb.r,cb.i,cb.dr,cb.g,cb.len,cb.linecnt,target.ull);  


// 	prof_cp0(); //  clear perf
// 	prof_cp30(); // start perf
        l=0;
        setconst(cb.r,cb.dr,cb.g,cb.len,cb.depth);
        Line_Gen (i,(btype*)&line1[0]);
        do { 
 	mfc_put(&line1, target.ull, cb.len*sizeof (int), tag1, 0 ,0);
        target.ull +=cb.targetoffs*sizeof(int);  
  	mfc_write_tag_mask(1 << tag1);
        if (++l==cb.linecnt) break;
        i =i+cb.di;
        Line_Gen (i,(btype*)&line2[0]); 
             
  	mfc_read_tag_status_all();
 	mfc_put(&line2, target.ull, cb.len*sizeof (int), tag2, 0 ,0);
        target.ull +=cb.targetoffs*sizeof(int);  
        mfc_write_tag_mask(1 << tag2);
        if (++l==cb.linecnt) break;
        i =i+cb.di;
        Line_Gen (i,(btype*)&line1[0]); 
             
  	mfc_read_tag_status_all();
        } while (1);

	mfc_read_tag_status_all();
 //	prof_cp31(); // stop perf 
 //	printf ("id:0x%llx %f %f %f %f %lld\n",id,cb.r,cb.i,cb.dr,cb.g,count);   
	return 0;
}
