#include <stdio.h>
#include "sdot_spu.h"


float A[DIM] __attribute__((aligned (16))); 
float B[DIM] __attribute__((aligned (16))); 
float C[DIM] __attribute__((aligned (16)));

//gewünschte Routine aussuchen:
// USE_SDOTMUL       : Skalarprodukt zweier Vektoren
// USE_SDOTMULCONST  : ebenso mit globalen Matrizen A und B 
// USE_SDOTMULV      : Skalarprodukt zweier Vektoren mit vec_float4
// USE_SDOTMULCONSTV : ebenso mit globalen Matrizen A und B 
// USE_SCOMMUL       : komponentenweise Multiplikation (mit Autovektorisierung per -ftree-vectorize)

#define USE_SDOTMULV 
//#define USE_SDOTMUL
//#define USE_SDOTMULCONST
//#define USE_SDOTMULCONSTV
//#define USE_SCOMMUL


float sdotmul(const float *a, const float *b, short int d) {

//sdotmul=sum(A[i]*B[i]) 
 short int i; float c=0;
 for (i=0; i < d; i++)  c +=a[i]*b[i];
 return c;
 }


float sdotmulconst(void) {
 short int i; float c=0;
 for (i=0; i < DIM; i++)  c +=A[i]*B[i];
 return c;
 }

vec_float4 fnull={0,0,0,0};

float sdotmulconstv(void) {
 short int i;
  vec_float4 cv,*pav, *pbv;
  pav=(vec_float4*) &A;
  pbv=(vec_float4*) &B;
  cv=fnull;
  for (i=0; i < (DIM >> 2) ; i++) cv +=*pav++ * *pbv++;     
 return spu_extract (cv,0)+spu_extract (cv,1)+spu_extract (cv,2)+spu_extract (cv,3);
 }

float sdotmulv(const float *a, const float *b, short int d) {
  short int i; 
  vec_float4 cv1,cv2,cv3,cv4,cv5;
  vec_float4 *pav=(vec_float4*) a, *pbv=(vec_float4*) b;
  cv1=fnull;cv2=fnull;cv3=fnull; cv4=fnull;cv5=fnull;
 for (i=0; i < (d/20) ; i++) {
  cv1 +=*pav++ * *pbv++; 
  cv2 +=*pav++ * *pbv++;
  cv3 +=*pav++ * *pbv++;
  cv4 +=*pav++ * *pbv++;
  cv5 +=*pav++ * *pbv++;
 }
 // hier käme für d%20 != 0  noch der Rest   
  cv1 +=cv2;
  cv3 +=cv4;
  cv1 +=cv5+cv3;
 return spu_extract (cv1,0)+spu_extract (cv1,1)+spu_extract (cv1,2)+spu_extract (cv1,3);
 }


float scommul(float* c,const float *a, const float *b,short int d) {
 short int i;
 for (i=1; i< d; i++) c[i]=a[i]*b[i];
 return 0.0;
}


int main(unsigned long long id)
{
  int r; short int i; float c;

  for (i=0; i<DIM;i++) {
    A[i]=i;
    B[i]=DIM-i;
  }

 for (r=0; r < REP; r++) 
  #ifdef USE_SDOTMULV
     c=sdotmulv(A,B,DIM); 
  #elif USE_SDOTMUL
     c=sdotmul(A,B,DIM); 
  #elif USE_SDOTCONSTV
     c=sdotconstv(); 
  #elif USE_SDOTMULCONSTV
     c=sdotmulconstv(); 
  #elif USE_SCOMMUL
    c=scommul(C,A,B,DIM);
  #endif 
 printf("ok,V1.0 done (0x%llx) c =%f\n", id,c);
 return 0;
}
