/* --------------------------------------------------------------  */
/* (C)Copyright 2001,2006,                                         */
/* International Business Machines Corporation,                    */
/* Sony Computer Entertainment, Incorporated,                      */
/* Toshiba Corporation,                                            */
/*                                                                 */
/* All Rights Reserved.                                            */
/* --------------------------------------------------------------  */
/* PROLOG END TAG zYx                                              */
#include <stdio.h>
#include <liblarge_matrix.h>

#define dim  64
#define dimx 64

float a[dim][dim] __attribute__((aligned (128))); 
float b[dim][dim] __attribute__((aligned (128))); 
float c[dim][dim] __attribute__((aligned (128))); 

float r,cs;

//C[i,j]=A[i,j]*B[i,j]+C[i,j] 

void matmul(void)
{
 short int i,j,k;
 for (i=0; i < dimx; i++)  
  for ( j=0; j < dimx; j++)

  
 //  for (k=0;k < dimx; k++)    
    c[i][j] +=a[i][j]*b[i][j];
  
 }


void msum(void)
{
 short int i,j,k;
 for (i=0; i < dimx; i++)  
  for ( j=0; j < dimx; j++)

  
 //  for (k=0;k < dimx; k++)    
    cs +=a[i][j]*b[i][j];
  
 }


void vmatmul(void)
{

 vec_float4 *pcv;
 vec_float4 *pav;
 vec_float4 *pbv;
 short int i;
 for (i=0; i < dimx; i++) 
  {
  pcv=(vec_float4*) &c[i];
  pav=(vec_float4*) &a[i];
  pbv=(vec_float4*) &b[i];

  *pcv++ += *pav++ * *pbv++;
  *pcv++ += *pav++ * *pbv++;
  *pcv++ += *pav++ * *pbv++;
  *pcv++ += *pav++ * *pbv++;
  *pcv++ += *pav++ * *pbv++;
  *pcv++ += *pav++ * *pbv++;
  *pcv++ += *pav++ * *pbv++;
  *pcv++ += *pav++ * *pbv++;  
  *pcv++ += *pav++ * *pbv++;
  *pcv++ += *pav++ * *pbv++;
  *pcv++ += *pav++ * *pbv++;
  *pcv++ += *pav++ * *pbv++;
  *pcv++ += *pav++ * *pbv++;
  *pcv++ += *pav++ * *pbv++;
  *pcv++ += *pav++ * *pbv++;
  *pcv++ += *pav++ * *pbv++;  
 }

}


void vmatmul2(void)
{

 vec_float4 *pcv,*pav,*pbv;
  short int i;
  pcv=(vec_float4*) &c;
  pav=(vec_float4*) &a;
  pbv=(vec_float4*) &b;


 for (i=0; i < dimx*(dimx>>2); i++) 
  {
   *pcv++ += *pav++ * *pbv++;
   }
}

void vmatmul3(void)
{

 vec_float4 *pcv,*pav,*pbv;
  short int i;
  pcv=(vec_float4*) &c;
  pav=(vec_float4*) &a;
  pbv=(vec_float4*) &b;


 for (i=0; i < dimx*(dimx>>5); i++) 
  {
   *pcv++ += *pav++ * *pbv++;
   *pcv++ += *pav++ * *pbv++;
   *pcv++ += *pav++ * *pbv++;
   *pcv++ += *pav++ * *pbv++;
   *pcv++ += *pav++ * *pbv++;
   *pcv++ += *pav++ * *pbv++;
   *pcv++ += *pav++ * *pbv++;
   *pcv++ += *pav++ * *pbv++;
  }
}




void vmatmul4(void)
{

 vec_float4 c0,c1,c2,c3,c4,c5,c6,c7,*pcv,*pav,*pbv,*pcx;
  short int i;
  pcv=(vec_float4*) &c;
  pav=(vec_float4*) &a;
  pbv=(vec_float4*) &b;
 
 for (i=0; i < dimx*(dimx >> 4); i++) 
  {
   pcx=pcv;
   c0=*pcv++; 
   c1=*pcv++;
   c2=*pcv++;
   c3=*pcv++;
   c0 += *pav++ * *pbv++;
   c1 += *pav++ * *pbv++;
   c2 += *pav++ * *pbv++;
   c3 += *pav++ * *pbv++; 
   *pcx++=c0; 
   *pcx++=c1;
   *pcx++=c2;
   *pcx++=c3;
  }
}



int main(unsigned long long id)
{
  int rep;
  short int i,j;
  for (i=0; i<dimx;i++) 
   for(j=0; j<dimx;j++) {
    a[i][j]=i+j;
    b[i][j]=2;
    c[i][j]=0;
  }
 cs=0;
for (rep=0; rep < 10000; rep++)  
   madd_matrix_matrix (dimx,dimx,dimx,&a[0][0],dim, &b[0][0],dim, &c[0][0],dim);
  //msum();
  r=c[2][2];
  printf("ok,V1.0 done (0x%llx) cs= %f, c[2,2]=%f c[10,10]= %f\n", id,cs, c[2][2], c[10][10]);

  return 0;
}
